
-- Model --

create table variables (
  _id           integer primary key,
  flow_id       integer not null,
  flow_version  integer not null,
  register      integer not null,
  data          blob not null
)
;;
create unique index variables_flow_id_flow_version_register
    on variables (flow_id, flow_version, register)
;;

-- Triggers --

drop trigger before_update_flows_data
;;
create trigger before_update_flows_data
before update of data on flows
begin
  insert into cleanups ( flow_id, flow_version, flow_data )
  values ( old._id, old.version, old.data )
  ;
  update flows
     set version = old.version + 1
   where _id = old._id
  ;
end
;;

drop trigger before_delete_flows
;;
create trigger before_delete_flows
before delete on flows
begin
  insert into cleanups ( flow_id, flow_version, flow_data, deleted )
  values ( old._id, old.version, old.data, 1 )
  ;
end
;;

create trigger after_delete_cleanups
after delete on cleanups
begin
  delete from fibers
   where flow_id = old.flow_id
     and flow_version = old.flow_version
  ;
	delete from variables
	 where flow_id = old.flow_id
	   and flow_version = old.flow_version
	;
end
;;
